package ClusterDriver;

public class SimilarityMatrix {



	String [][] generatedData; 
	String [][] originalData;
	public double avgDisclosure;
	public int uniqueRecord = 0;
	double [][] similaryMatrix;


	public SimilarityMatrix(String [][] generatedData, String [][] originalData)
	{
		this.generatedData = generatedData;
		this.originalData = originalData;

		/**
		 *  computing average similarity over generated data set and the original data set.
		 */
		int row = generatedData.length;
		int col = originalData.length;
		double totalDisclosure = 0;
		int totalNumber = 0;
		similaryMatrix = new double[row][col];
		for(int r = 0; r < row ; r++)
		{
			boolean counted = false;
			for(int c = 0; c < col; c++)
			{
				similaryMatrix[r][c] = computeSimilary(generatedData[r], originalData[c]);
				totalDisclosure += similaryMatrix[r][c] ;
				totalNumber++;
				if(similaryMatrix[r][c] == 1 && !counted)
				{
					uniqueRecord++;
					counted = true;
				}
			}
		}

		avgDisclosure = totalDisclosure/totalNumber;

	}



	/**
	 *  computing similarity between two records.
	 */
	private double computeSimilary(String[] record1, String[] record2)
	{
		if(record1.length != record2.length)
		{
			System.out.println("ERROR: records should have a same size!");
		}
		int i = 0;
		double matchNum = 0;
		int colNum = record1.length;
		while(i < colNum)
		{
			try{
				if(Double.parseDouble(record1[i]) == Double.parseDouble(record2[i]))
				{
					matchNum++;
				}
			}catch(Exception ex)
			{
				if(record1[i].equals(record2[i]))// && !record1[i].equals("999999"))
				{
					matchNum++;
				}
			}

			i++;
		}
		return matchNum/colNum;
	}


	public void printMatrix()
	{
		for(int r = 0; r < similaryMatrix.length ; r++)
		{
			for(int c = 0; c < similaryMatrix[0].length; c++)
			{
				System.out.print(similaryMatrix[r][c] + "\t");
			}
			System.out.println();
		}
	}


}
