package NominalToNumerical;
import java.util.AbstractList;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class NTN {

	
	public ArrayList<HashMap<Double,String>> encoding;
	public double[][] nomMatrix;
	public boolean[] nominal;
	
	public NTN(String[][] matrix, boolean[] nominal){
		
		System.out.println("NTN "); 
		this.nominal = nominal;
		int col = matrix[0].length;
		int row = matrix.length;
		nomMatrix = new double[row][col];
		encoding = new ArrayList<HashMap<Double,String>>();
		
		for (int c =0 ; c<col; c++){
			HashMap<Double,String> mapping = new HashMap<Double,String>();
			double encodeCount =0;
			for(int r =0; r<row; r++){
				if(!nominal[c]){
					nomMatrix[r][c] = Double.parseDouble(matrix[r][c]);
				}else{
					String nm = matrix[r][c]; 
					if(mapping.containsValue(nm)){
						for(Double key: mapping.keySet()){
						    if(mapping.get(key).equals(nm)){
						    	nomMatrix[r][c]=key;
						    }
						}
					}else{
						nomMatrix[r][c] = encodeCount;
						mapping.put(encodeCount,nm);
						encodeCount++;
					}
				}
			}
			encoding.add(mapping);
		}
	}
	
	public String[][] decode(double[][] enMatrix){
		int col = enMatrix[0].length;
		int row = enMatrix.length;
		String[][] resMatrix = new String[row][col];
		for (int c =0 ; c<col; c++){
			for(int r =0; r<row; r++){
				if(!nominal[c]){
					resMatrix[r][c] = Double.toString(enMatrix[r][c]);
				}else{
					double nm = enMatrix[r][c]; 
					resMatrix[r][c] = encoding.get(c).get(nm);
				}
			}
		}		
		return resMatrix;
	}
	

	
	//*Test Case for Encoding*/
	public static void main(String[] args){
		String[][] Data = {{"BIG","me","0"},{"BIG","me","0"},{"SMALL","you","0"}};
		boolean[] nom ={true,true,false};
		NTN ntn = new NTN(Data,nom);
		System.out.println(Arrays.deepToString(ntn.nomMatrix));
		System.out.print(Arrays.deepToString(ntn.decode(ntn.nomMatrix)));
	}
	
	
}