package Statistics;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class Calculator {
	


	public static double calDisclosureRisk(double[][] nomMatrix,
			double[][] centroids, List<Integer> clusters) {
		// TODO Auto-generated method stub
		int numClusters = centroids.length;
		int rows = nomMatrix.length;
		int disclosured = 0;

		double[] maxValues = getMaxValues(nomMatrix);
		for (int numClu = 0; numClu < numClusters; numClu++) {
			double distance1 = 99999999;
			double distance2 = 99999999;
			int index1 = 0;
			int index2 = 0;
			for (int r = 0; r < rows; r++) {
				double distance = calDistance(centroids[numClu], nomMatrix[r],maxValues);
				if (distance < distance1) {
					distance1 = distance;
					index1 = r;
				} else if (distance < distance2) {
					distance2 = distance;
					index2 = r;
				}
			}
			disclosured += (numClu == clusters.get(index1)) ? 1 : 0;
			disclosured += (numClu == clusters.get(index2)) ? 1 : 0;
		}

		return disclosured/(double)rows;
	}
	
	
	public static double[] getMaxValues(double[][] matrix){
		
		int col = matrix[0].length;
		double[] max = new double[col];
		int rows = matrix.length;
		for(int c=0; c<col; c++){
			for(int r =0; r<rows; r++){
				if(matrix[r][c] > max[c]){
					max[c] = matrix[r][c];
				}
			}
		}
		
		
		return max;
		
	}

	public static int calUniqueRecords(double[][] nomMatrix, double[][] clusters) {
		int count = 0;
		int rows = 0;
		int rowsClu = 0;
		int size = nomMatrix.length;
		int sizeClu = clusters.length;
		for (rowsClu = 0; rowsClu < sizeClu; rowsClu++) {
			for (rows = 0; rows < size; rows++) {
				//System.out.println(rows);
				if (Arrays.equals(nomMatrix[rows], (clusters[rowsClu]))) {
					count++;
					break; //Only want one match
				}
			}
		}
		return count;
	}

	public static double calSDKmembers(List<Integer> clusters) {
		HashMap<Integer, Integer> kmembers = new HashMap<Integer, Integer>();
		int sum = clusters.size();
		for (int i : clusters) {
			if (kmembers.containsKey(i)) {
				kmembers.put(i, kmembers.get(i) + 1);
			} else {
				kmembers.put(i, 1);
			}
		}

		double[] data = new double[kmembers.size()];
		int i = 0;
		for (int k : kmembers.keySet()) {
			data[i] = kmembers.get(k);
			i++;
		}
		Statistics st = new Statistics(data);
		return st.getStdDev();
	}

	public static int calMinKmember(List<Integer> clusters) {
		int min = 999999999;
		HashMap<Integer, Integer> kmembers = new HashMap<Integer, Integer>();
		int sum = clusters.size();
		for (int i : clusters) {
			if (kmembers.containsKey(i)) {
				kmembers.put(i, kmembers.get(i) + 1);
			} else {
				kmembers.put(i, 1);
			}
		}

		for (int k : kmembers.keySet()) {
			int current = kmembers.get(k);
			if (current < min) {
				min = current;
			}

		}
		return min;
	}

	public static double calAveragemembers(List<Integer> clusters) {
		HashMap<Integer, Integer> kmembers = new HashMap<Integer, Integer>();
		int sum = clusters.size();
		for (int i : clusters) {
			if (kmembers.containsKey(i)) {
				kmembers.put(i, kmembers.get(i) + 1);
			} else {
				kmembers.put(i, 1);
			}
		}

		double[] data = new double[kmembers.size()];
		int i = 0;
		for (int k : kmembers.keySet()) {
			data[i] = kmembers.get(k);
			i++;
		}
		Statistics st = new Statistics(data);
		return st.getMean();
	}

	public static double calDistance(double[] a, double[] b, double[] max) {
		int cols = a.length;
		double sum = 0;
		for (int c = 0; c < cols; c++) {
			sum += Math.pow((a[c] - b[c])/(max[c]+0.0000001), 2); //Avoids divide by zero errors
		}
		return (Math.sqrt(sum));

	}
}
